<?php

namespace chillerlan\FastRoute\DataGenerator;

class GeneratorMB extends DataGeneratorAbstract implements DataGeneratorInterface{

	protected $approxChunkSize = 30;

	public function processChunk(array $regexToRoutesMap):array{
		$routeMap = [];
		$regexes = [];
		$markName = 'a';

		foreach($regexToRoutesMap as $regex => $route){
			$regexes[] = $regex.'(*MARK:'.$markName.')';
			$routeMap[$markName] = [$route->handler, $route->variables];

			++$markName;
		}

		return [
			'regex'    => '~^(?|'.implode('|', $regexes).')$~',
			'routeMap' => $routeMap,
		];
	}
}

