<?php

namespace chillerlan\FastRoute\Dispatcher;

class DispatcherMB extends DispatcherAbstract{

	public function dispatchVariableRoute(array $routeData, string $uri):array{

		foreach($routeData as $data){

			if(!preg_match($data['regex'], $uri, $matches)){
				continue;
			}

			list($handler, $varNames) = $data['routeMap'][$matches['MARK']];

			$vars = [];
			$i    = 0;
			foreach($varNames as $varName){
				$vars[$varName] = $matches[++$i];
			}

			return [
				self::FOUND,
				$handler,
				$vars,
			];
		}

		return [self::NOT_FOUND];
	}

}
