<?php

namespace chillerlan\FastRoute;

use chillerlan\FastRoute\DataGenerator\DataGeneratorInterface;
use chillerlan\FastRoute\RouteParser\RouteParserInterface;

class RouteCollector{

	private $routeParserInterface;
	private $dataGeneratorInterface;

	public function __construct(RouteParserInterface $routeParser, DataGeneratorInterface $dataGenerator){
		$this->routeParserInterface   = $routeParser;
		$this->dataGeneratorInterface = $dataGenerator;
	}

	/**
	 * Adds a route to the collection.
	 *
	 * The syntax used in the $route string depends on the used route parser.
	 *
	 * @param string|string[] $httpMethod
	 * @param string          $route
	 * @param mixed           $handler
	 */
	public function addRoute($httpMethod, string $route, $handler){
		$routeDatas = $this->routeParserInterface->parse($route);

		foreach((array)$httpMethod as $method){
			foreach($routeDatas as $routeData){
				$this->dataGeneratorInterface->addRoute($method, $routeData, $handler);
			}
		}
	}

	public function getData():array{
		return $this->dataGeneratorInterface->getData();
	}

}
